Page MenuHomePhabricator

Theming REALLY needs to happen more than Development. And it doesn't need to be a dark based theme.
Closed, DuplicatePublic

Description

We constantly get criticized for our less than modern look. I feel as though most users could let some of the other inefficiencies and issues go if our theme at least looked good. And aesthetically, accessibility, and statistically the type of theme that is going to appeal to the most users is not going to be a dark theme. We can still have the dark theme as an option, but we shouldn't ship it as default, and this include's raster's updated theme flat which is basically just a flattened version of dark. Look around and literalliy no one ships with a dark theme. Windows, Mac OS, Android, Chrome, I OS, Gnome, KDE, XFCE, etc..., etc..., etc... there is a reason. The out of the box experience should cover the largest base of users possible. A dark theme is not going to accomplish that. A dark theme is a niche. Cedric has addressed this already with the website and it also applies to our default theme. Both need to be redone and really there should be an emphasis on this theming over development at this point because it is the appearance that is costing us users not functionality. I see it every day in online forums, chats, irc, blogs about E, etc..., etc..., etc... We REALLY need to prioritize this and theme, and do it the right way. Google material design has been suggested by many as what we should do. I'm not sure. Cedric's push to work on our appearance was not met well or accepted among our developers, but simply this has to change. It is killing us. I've attached an IRC discussion in #edevelop from several developers about this theming. I wanted to put it here on Phab and allow us to all have a discussion to work this out. This really is a serious issue and I hope this is addressed and not just blown off for personal preferences or lack of passion about doing a theme. Seriously do some research and contribute this discussion unbiasedly.

<okra> we really should say to hell with the dark theme, to hell with the dark website, etc..., etc... cedric brought this up once more and seeing more reactions of people using E like the one in #e right now... it isn't a coincidence. The website, application themes, wm themes don't need to be so nuanced with styling, and odd color combinations of dark and blue.
<okra> as cedric said, he was referring to the website but it refers to the default theme the website matches as well. It's bad. cedric suggested going with something google material design related... which now seems to be a focus of ajwillia_ms new work as well. Really the out of the box or initial impression of our stuff shouldn't be the dark theme that our website and toolkit and desktop use.
<okra> that doesn't mean we can't still have the dark theme and others... but the dark theme is a niche. Statistically it won't be a favorite. Our defaults should follow statistics of what a majority would find aesthetically pleasing and not a minority. Again cedric provided a lot of these numbers.
<vivia> okra: to be honest many people seem to be extremely fond of dark themes, and it seems to have a higher correlation with developers than the general public. it's kind of niche
<vivia> oh, gmta :)
<okra> vivia, :)
<okra> and I get @raster is working on a new theme... but its just a flat version of what we already have
<okra> it isn't improving anything in that department.
<vivia> what was the reaction in #e btw? I did join but it was already gone
<okra> as you said though vivia among the developers its the opposite... to hell with the statistics and a design that covers the statistic majority we refuse to move from our niche design and look/feel
<okra> vivia, just more people saying E looks old/1990s/theme is bad/lack of themes
<vivia> hehe, i see
<okra> I cringe everytime I visit e.org or see elm apps, even ephoto that I wrote. dark text on light backgrounds statistically will please the widest range of users aesthetically.
<brokenshakles_> okra, but I like dark and blue
<vivia> higher contrasts are better for accessibility
<brokenshakles_> but I've always wondered why we dont have a selection of themes instead of just a single degault
<brokenshakles_> default*
<vivia> I'm not sure there aren't color-blindness types who would have trouble telling apart blue from dark gray
<okra> brokenshakles_, because a long time ago in our initial design of libraries and how things work we made it too difficult to create themes
<brokenshakles_> okra, is that being redesigned as part of this?
<okra> vivia, it's a problem. Simotek has been trying to get e.org to websafe colors methinks but to me it just shouldn't be gray on gray text/background at all.
<okra> brokenshakles_, no
<brokenshakles_> okra, and dark text on light backgrounds kills the eyes if you stare at it for long periods, so we will still need a dark theme for devs.
<brokenshakles_> so there is a builtin population that will want the current theme, but the real solution is choice, I'm afraid.
<brokenshakles_> that and lightening up the text gray for the current theme, the fact that text contrast to the background is too low is a very valid complaint.
<okra> brokenshakles_, rather quite the opposite
<brokenshakles_> ??
<okra> brokenshakles_, most studies have found reading dark text on light backgrounds is better for the eyes
<vivia> billiob: there?
<brokenshakles_> Then why do I always get a headache when I try it?
<okra> brokenshakles_, this is why you even see that trend in e readers for people who stare and read books rather than light text on dark background
<vivia> anyway, billiob had shown me some "solarised" theme
<vivia> which is the same contrast as reading a book in the shadow... not too high contrast, but dark on white
<vivia> and someone said that this felt like the easiest for the eyes
<okra> vivia, would love to see this
<vivia> actually it's the first result on ddg
<vivia> http://ethanschoonover.com/solarized
<vivia> for the lazy, does redshift work on e? :)
<brokenshakles_> vivia, those accent colors look horrible on my screen
<brokenshakles_> but the general concept is good
<vivia> brokenshakles_: I tried temporarily disabling redshift to see how it's supposed to look like and I went "OUCH MY EYES"
<vivia> (yes I do have it set to quite an aggressive color temperature / brightness)
<TAsn> vivia, probably yes (in X), but not in Wayland.
<vivia> TAsn: ahh, so it should operate on that level. then yeah
<TAsn> (redshift is X only, in Wayland, the compositor needs to implement it)
<brokenshakles_> vivia, looks like the designer cared more about the color value relationships and less about if the primary accent colors where actually the colors described.
<vivia> :), I can't judge for myself right now, but the concept is what I remembered as very interesting
<billiob> vivia: back :)
<vivia> b :)
<vivia> +w
<ajwillia_ms> vivia: netstar added solarised theme to edi :)
<netstar> hi-
<vivia> hi :)
<okra> I think users could let a lot of the other inefficiencies go if things at least looked good... but we seem so stuck on this gray/black/blue theme ... and it is never going to look good.
<netstar> I kind of agree
<netstar> I STILL love bling theme
<okra> netstar, it was at least dark text on a light bg
<ajwillia_ms> Bling was cool - but a little too animated
<okra> I seriously can't think of any desktops that ship out of the box with a dark theme.
<okra> other than E.
<netstar> I've tried flat but I'm not convinced by the contrast
<ajwillia_ms> okra: I think “we like it that way”
<okra> not windows, not mac, not gnome, not kde, not chrome, not android
<ajwillia_ms> okra: and not Fyne ;)
<vivia> android used to but switched away from it
<okra> ajwillia_ms, "we" very well may but statistically the majority of our users won't.
<netstar> Theming def needs to be addressed.
<okra> and by theming needs to be addressed I don't mean taking the same colors, same scheme, etc... and just making it flat like raster's theme is doing
<netstar> Is some sort of transitional layer possible to convery normal thoughts into edc?
<netstar> *convert
<okra> eflete
<netstar> Yeh it's not seen any love for ages
<netstar> the built-in theme was quite promising
<okra> or enventor
<okra> https://www.enlightenment.org/docs/start#ThemesEdjeEDC
<okra> anyhow.
<okra> I'm taking this chat and sticking it in a phab ticket and sending a mail to the list
<okra> I'm sure that this will get rejected but it must be said.
<netstar> TBH I really like a redmond theme
<vivia> okra: i think the biggest argument is accessibility, then statistics
<vivia> the rest just comes down to personal preferences

Related Objects

stephenmhouston removed zmike as the assignee of this task.Feb 16 2018, 2:37 PM

the choice to be dark is based on differentiation. what i am seeing here is an argument for "i want us to be the same because it's more common". note common, not popular. even if it were more popular in the general population (if everyone is light by default is it popular or just what you get if you like it or not?), what is it among the kinds of users who use linux, bsd etc. and would make a choice on their window manager/desktop etc. etc.? get statistics THERE and then you have an argument. the above seems more of and argument of preferences. unless you want to argue that the E (or EFL choosing developer) is really targeting/part of the mass market who just buy a PC or a Mac or a phone and otherwise don't care to ever change what it runs and take it as it is? let's start there. can we agree that our market is people who are actively looking to make a choice of something other than the default?

now onto differentiation:

https://en.wikipedia.org/wiki/Product_differentiation
http://smallbusiness.chron.com/advantages-product-differentiation-strategy-17691.html
http://www.more-for-small-business.com/product-differentiation.html
etc.

i'm sure everyone can search for product differentiation as much as i can.

for a start. if you are small then it's an advantage to be DIFFERENT. when your competition is FREE you can't be cheaper, so how will you get people to move from their default?

https://www.nngroup.com/articles/the-power-of-defaults/

when their default already is "light background, dark text" then why change to one that's all the same? it's exceedingly hard to fight the default, so being the same makes that fight oh so much harder. you have to stand out to get any attention as well as to justify a move. the argument above is to be the same to make this easier. i beg to differ.

some of the above also has nothing to do with "dark background". the "looks old fashioned" complaints have to do with bevels, gradients and shadows, not dark. otherwise it'd be simpler to just complain about it being dark than "looking old fashioned". it's less words needed to get to your point. i'd like to see statistics or information that counters this point, as i'm relatively certain that this is the case (and it was indicated that this is too above in the irc log).

several people in the above do think that dark backgrounds are easier to deal with and less strain on the eyes for them.

Enlightenment.org does now follow contrast minimums as suggested etc. so I don't think there is any argument there other than dark or light backgrounds by default.

also blue on grey... i am not sure is a common color issue. red vs. green affects about 10% of people, but i know of no major color blindness issues of blue vs dark grey, unless I guess if you are totally lacking color vision... and that is not exactly common enough to change default looks for such a tiny percentage of people. (http://www.colourblindawareness.org/colour-blindness/types-of-colour-blindness/ - 0.003% of people statistically might lack color vision).

now there is probably a good "scientific" argument either way for white or dark backgrounds:

http://uxmovement.com/content/when-to-use-white-text-on-a-dark-background/

a GUI, i would argue is scanned, not read like a book. users look for key words by scanning for them, thus light on dark would probably be better. in fact the argument is for a lesser contrast between the text and background to avoid strain... which several people above mention too.

but in the end we're arguing a DEFAULT. your default sends a message, even if it's changeable later. part of the work to do the flat theme (which I am slowly working on) is to also make things easier to recolor (as well as make it easier for developers to do theme work and not need to learn more artistic skills, as well as to handle the "you look old fashioned" issue). offering different color class schemes as options that are EASY to select would basically nuke the problem into just a marketing issue of defaults (see above) as those who come for reasons other than it being different in look can go have their color scheme of choice. so perhaps helping on that theme will be a path to making that better. just like E asks for N different scaling sizes on first run, it could also ask for maybe one of 8 or 9 different color schemes (some dark, some light), and then it's kind of all moot beyond marketing message.

one thing i think we ALL agree on is that there does need to me more work on themes. they are huge undertakings. a flat theme should simplify things a bit in the default, but we need show-off themes to show the power of what we have, and i kind of insist on these because this is how E started and was it's whole reason to exist, by being so unashamedly "different to the norm". being "like everyone else" would be ripping out the heart and soul of what started Enlightenment and what it was made to be. this is what enlightenment started as:

http://step.polymtl.ca/~coyote/picturesd/linux/screenshot_8.jpg

and it gained the biggest amount of publicity because of the next theme I did:

http://step.polymtl.ca/~coyote/picturesd/linux/screenshot_9.jpg

that was the "DR 0.13" theme and it really got attention. a move to "let's just be the same as everyone else" would have had enlightenment look like:

http://step.polymtl.ca/~coyote/picturesd/linux/cde.gif

or

http://step.polymtl.ca/~coyote/picturesd/linux/afterstep1.gif

going in the direction of "let's just fundamentally rip out the heart and soul of enlightenment" would make me very sad. extremely sad. it's betraying your very foundations. enlightenment was always built with the "be 'out there' by default and allow people to them change it however they like, and if they like it to be conservative and the same as everyone else, they can do that. that's what themes are for".

i do not think an argument over light or dark by default is going to do anything by devolve into personal preferences and everyone citing that theirs are better because of x/y/z. i don't think it will be productive at all. but if we can turn this into "let's make it easier to have alternate color schemes - let's find a path that makes that easy" then i see positivity. there are patches up for review on making color classes more maintainable by having a tree structure with parent and child colors so you can more easily determine a color scheme with fewer colors rather than need 100+ of them. part of this is also working out good color class naming schemes etc. for the theme which is actually still very adhoc and "undocumented".

summary:

being dark is a MARKETING decision to differentiate by default. there are huge bodies of work out there backing differentiation as an important strategy especially since we're not going to compete on price, nor on breadth and depth of installations, documentation etc. (while we work on that it's not a feather in our cap). what we have is an environment that is outstandingly more flexible than most others, especially when it comes to customizing the look and feel of it. we have a desktop that is on the lower or lowest end of resource usage even if it can match or beat the larger ones in visual capability (still doing effects, shadows, etc. etc. - no compromises there). those are our strengths. being different visually is a marketing nod to the first. the second only really concerns people who do benchmarking, or when they just hear "use this if you want to have less resources used" and that would come as a result of many people trying it and spreading the word. i think it'd be a bad marketing decision to change the default dark. note that i'm probably not that biased here. i did the light e16 theme, bling and b&w with a start white bg. i did the dark theme too and prior dark themes. i've been on both sides of this fence and done both and i see positives in both. but ... for reasons of NOT following the crowd... i think being dark is a good thing.

as i said above... helping with a flat theme will make it EASIER to recolor and offer options and my take is an option handed to users on a silver platter (e.g. in e's wizard) is the best solution. pre-made color class schemes for both dark and light and then we can stop arguing unless you really want to make a case where for a small player to NOT differentiate visually by default is a bad idea?

Enlightenment.org is read like a book obviously and not scanned so if that is the argument you are going to make then it fits your argument to have a light background and dark text. By the way, regardless of contrast minimums now met, Enlightenment.org looks horrible. I mean it is truly bad. Anyhow...

No one is suggesting to remove the heart and soul of E. You can be different without having a niche theme. Certain looks get popular for a reason. A lot of studying goes into aesthetics and the statistics do exist that the majority of users and people will prefer something light background with dark text. Google, you seem to have done well with other articles. You will find that. These massive companies or software with massive user bases don't make these decisions out of the blue. They study. They follow their design based on a TON of research, science, and statistics. They all have similar designs for a reason.

At any rate we can all agree that the look of E and the website and related apps etc... right now is not good. We all really need to put a focus into getting back to having a really awesome great look.

If you asked me the heart and soul of E used to be good design and awesome looks and that is clearly what has been ripped away - not being different. As we prioritize things that need to be done I really think improving our design and look should be #1 on the list. Even before interfaces. Or we are going to fall so far behind it will be hard to recover. As I said users will be fine to ignore some imperfections/inefficiencies/frustrations that come with the massive amount of efl development and changes going on if their desktop and apps and product actually looked really good.

If we are being dark for marketing purposes, that is HORRIBLE and a HORRIBLE way to market. We can differentiate without doing something stupid like that. I could create a brand of toilet paper and differentiate it by saying it's made of splintered woods and razor blades. That doesn't make differentiation successful. Popular is popular for a reason. I'm not making an argument to not differentiate. I'm making the argument that the current differentiation plan is one of the worse things I've ever seen. You don't choose to be worse because being worse is different to try and gain users.

For the record - I would be all on board with taking a flat theme and offering it in light and dark versions. That would appease everyone and I agree with you on that being a solid solution.

But the website definitely needs to be light bg dark fg. Cedric already made the point and provided the statistics you should see. You posted an article in your response that would prove that point as well. E.org also needs a ton of layout work, better images, etc..., etc...

 Enlightenment.org is read like a book obviously and not scanned

Maybe you missed the fact I was talking about theme. GUI. Not website there. I was pretty clear that a "GUI is scanned not read". As opposed to a website which you are right is generally read, not scanned.

No one is suggesting to remove the heart and soul of E. You can be different without having a niche theme. Certain looks get popular for a reason

I believe you are suggesting just that. To summarize what you say: "We need to look just like everyone else looks because since everyone looks that way, it's popular and thus we must". The heart and soul of E is NOT to look like everyone else. Not by default for sure.

A lot of studying goes into aesthetics and the statistics do exist that the majority of users and people will prefer something light background with dark text

Please refer to my question about "target market" not "everyone at large". I would hazard to say that dark bg with light on top is more popular among our target market. Above vivia made precisely that statement. If you just look at the kind of desktops that these kinds of people use, you will find a huge number are tiled, with big black/dark terminals everywhere with light text. IT's immensely common within this segment and that I say is the segment that we're likely to see users from, not from the "I just take the defaults" segment.

Enlightenment.org looks horrible

Well someone spend the time and effort to do the work on it. All of it is in git. Year after year it only ends up in the end being me doing it... so anything you suggest being done basically is asking me to do it. After 20+ years this is my conclusion. You want to make it different... well you can guess. Right now I like keeping e.org consistently colored with the default theme because at least things are consistent.

At any rate we can all agree that the look of E and the website and related apps etc... right now is not good

As you might tell.. I don't agree. At least not in terms of light vs dark. I agree that we probably need to flatten the default theme and I have been doing that. It also opens the door to easier colorization, as already mentioned. If you can come up with a look for the website that really looks good and is consistent, and do the work of fixing images/icons .. or find someone or some group to do it... then go for it, but don't make it "programmer art". You know what I mean by that. :)

If you asked me the heart and soul of E used to be good design and awesome looks and that is clearly what has been ripped away - not being different.

I refer to screenshots linked above... :) It is I who chose to do that and I'm telling you the choice was made to be different and just totally "out there cool and do things no one else does or can do".

The compromise I was aiming for was a flat theme (well still with shadows here and there - material design isn't even totally flat either). It would pretty much address most of it and make it easy to do other color schemes as well. I also was going to then take time to do some totally crazy themes as well in the style of the original E themes like linked above.

I really think improving our design and look should be #1 on the list. Even before interfaces

I think both are important, but address different issues. Interfaces is important from an internal technical point of view. It can't keep dragging on forever. Themes is important from an image/external point of view. Both are important.

If we are being dark for marketing purposes, that is HORRIBLE and a HORRIBLE way to market. We can differentiate without doing something stupid like that. I could create a brand of toilet paper and differentiate it by saying it's made of splintered woods and razor blades.

This is where I think you are just relying on personal preference and a very superficial concept of what is popular. Please see my comments about target market. Let me look at the kinds of software that this market uses and the look they have:

https://www.google.com/search?q=visual+studio+code&dcr=0&source=lnms&tbm=isch&sa=X&ved=0ahUKEwis67nf2K3ZAhXIyLwKHXHPDNQQ_AUICigB&biw=1123&bih=1279
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=u4OIWvvHCIyF8gXK26vgDQ&q=atom+editor&oq=atom+editor&gs_l=psy-ab.3..0l9j0i30k1.15477.16756.0.16958.11.11.0.0.0.0.143.1041.0j9.9.0....0...1c.1.64.psy-ab..2.9.1037...0i67k1.0.17nWPaQFv3c
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=zYOIWu-AA4KN8wWK0YO4BQ&q=hacking+code+linux&oq=hacking+code+linux&gs_l=psy-ab.3...37925.40252.0.40420.18.15.0.1.1.0.246.1725.0j11j1.12.0....0...1c.1.64.psy-ab..5.10.1335...0j0i67k1j0i30k1j0i5i30k1j0i24k1.0.VYlaS5CDC9U
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=9oOIWqf1AsWe8QXT1JroDQ&q=coding+linux&oq=coding+linux&gs_l=psy-ab.3..0j0i8i30k1j0i24k1l2.20592.22096.0.22298.12.12.0.0.0.0.155.1281.3j8.11.0....0...1c.1.64.psy-ab..1.11.1280...0i67k1.0.LOT_x0HNOf4
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=DYSIWsTMCcvQ8wXEyJiADQ&q=linux+desktop&oq=linux+desktop&gs_l=psy-ab.3..0l10.20412.21989.0.22239.13.10.0.3.3.0.151.1171.0j10.10.0....0...1c.1.64.psy-ab..0.13.1194...0i67k1.0.BBpR-b9C4GE
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=JISIWvfjAYqw8wWgqJ3gCQ&q=sublime+text&oq=sublime+text&gs_l=psy-ab.3..0j0i67k1j0l8.155506.157784.0.158105.12.12.0.0.0.0.139.1264.0j11.11.0....0...1c.1.64.psy-ab..1.11.1263....0.efBbJbosBXE
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=54SIWqb6Mcr_8QWiiKKYDQ&q=ide&oq=ide&gs_l=psy-ab.3..0l4j0i67k1j0l5.15218.15522.0.15650.3.3.0.0.0.0.109.324.0j3.3.0....0...1c.1.64.psy-ab..0.3.324....0.pa7TTcmLeXo
https://www.google.com/search?dcr=0&biw=1123&bih=1279&tbm=isch&sa=1&ei=MIWIWuqMKcWY8QXYmaDwDA&q=unix+porn&oq=unix+porn&gs_l=psy-ab.3...5796.6986.0.7260.9.9.0.0.0.0.120.752.2j5.7.0....0...1c.1.64.psy-ab..2.5.552...0j0i67k1j0i30k1j0i8i30k1j0i24k1.0.tUK4sS5nVts

(i hope those end up working) but it's google image searches for:

"visual studio code"
"atom editor"
"hacking code linux"
"coding linux"
"linux desktop"
"sublime text"
"ide" (ignore pictures of ide cables and hdd's)
"unix porn" (a whole subreddit devoted to this)

Please note the immense proportion of these all having dark backgrounds with light text. My argument for dark bg is based on having done research into what is popular and common WITHIN a target audience. It is not your grandma or the average Joe. the average Joe will never use enlightenment or care what it is. They will use windows. The less average Joe will just use macos on the mac they bought. A much smaller niche uses Linux and an even smaller niche do something other than just use a default Ubuntu install or similar. Do we agree or not agree that the target audience for E is not a mass market audience but a niche one? If the audience was the average Joe I would agree with you probably on light bg, but it is not. It never has been.

I don't think this will prove productive unless we can all come to some common view of a target audience first. And that will need more than you and me going back and forth. It needs a much larger group discussion on that that also includes users. I'm simply stating why I think a change of defaults is bad and why I think the current color scheme as a default is actually a pretty good one.

For the record - I would be all on board with taking a flat theme and offering it in light and dark versions. That would appease everyone and I agree with you on that being a solid solution.

We agree on this. The way to make this happen is to help make the flat theme happen sooner. I think at least this is a positive point we can move on with for now. Doing a whole theme redo on my own is a lot of work. I spend maybe a day here and there on it. Right now I'm back on ecore eo/interfaces work. At least moving it forward a bit. There is much more to do there too... but I agree - themes need work too.

But the website definitely needs to be light bg dark fg. Cedric already made the point and provided the statistics you should see. You posted an article in your response that would prove that point as well. E.org also needs a ton of layout work, better images, etc..., etc...

At this point I don't plan on touching the website as I think the theme is a higher priority. As above... it is in git. the css is there in the www git... :) But also need to change images both in www-content and www too. But I think holding off on this until at least we can be on the same page on target market etc. ... is probably a good idea.

I think if someone strongly wants to make a light theme, they could try to make it.
It might even become the default if it is cool enough...

But you can't force someone to make a theme they don't want to make.
If someone wants to, they can start the theme, get some people interested and then think of making the default after.
I am sure people would be happy to have a good light theme even if it is not the default.

Btw, is there some existing tickets or discussion for how to make theming faster/simpler than it is now? or nothing can be done it's long/hard and that is all? :)

But you can't force someone to make a theme they don't want to make.

while right, let's take this as a discussion on what the default out-of-the-box look should be. it would guide work on the default theme. i see 3 things here:

  1. there needs to me more theme work (more themes with more variety and higher quality available for people)
  2. the default theme needs to be "modernized" (i.e. flat). (underway)
  3. there is a disagreement on the overall color scheme direction. dark or light.

no one disagrees on 1 or 2. you are making a point related to no. 1 in that making themes easier to make would hopefully help this point. the disagreement really is on no. 3.

as an aside, i was in '#archlinux' yesterday and there was a question about fonts, suggested an env var and a screenshot as to the results. i got 3 responses to the screenshot. 2 were "wow". i asked and they both preferred dark. 1 response was "i prefer beige colors" (i.e. light). so my massive sample size of 3 people shows a 66% preference for dark. i would argue that the kinds of people on '#archlinux' would be a very core target as opposed to "your grandma" as she would never go around choosing a new wm. the people in #archlinux would. :)

conr2d added a subscriber: conr2d.Feb 19 2018, 4:36 PM

IMHO, that the light theme is preferred commonly to the dark one is controversial, but more fundamental reason here is TOO DIFFICULT theme customization.

Light theme, OK cool. If there is someone who can make and maintain it for a long time, moreover users of E prefer it to darker, we might be able to switch default theme with it. However, our theme written in EDC is too complex to make. (and weak to keep compatibility during version upgrade, because its functional parts depend on C code too much. If we recall the main benefit of static binary theme compared to theming ways of other UI framework, it's ridiculous.) Discussion for switching theme or not can be meaningful only when there are many theme writers. Who will keep writing THAT THEME?

I've written EDC for 3yrs, but I gave up migrating GTK theme to E, because it requires too much time to write theme for E. Also it requires total understanding of Elementary widgets. For example, some widgets receive ("something,finished", "elm") signal from theme to trigger an event when its animation is finished. I know it, because I write or modify Elementary code by myself, but can we expect reading code from theme writers?

I think we should provide easier way to theme customization like css in GTK, because we cannot separate functional parts from EDC at this moment. If some configurable theming file (describing color, padding, image resources, fonts, animations, etc) can be compiled with functional EDC, writing theme would be easier.

indefini added a comment.EditedFeb 19 2018, 5:22 PM

I think most people agree that it's too difficult.
Sometimes I think everybody should give up writing themes until the next edje (bob?) / until it becomes easier.

I also think like you that designers cannot write a theme. You need to be a coder/designer like raster and that is a rare species :)

So I think each widget should have a contract/grammar/rules like this widget needs this state, this signal etc... + some docs explaining what they do and show in the original theme.
And when they try to compile their theme, they get a bunch of errors like "missing state, missing element, signal...".
And this contract could allow new features but wouldn't allow breaking changes...

Also I want to add on "it takes to much time" thing.
With enventor you can edit your edc, but it compiles the edc and the latency is killing me. I want to see the changes in live without recompiling a file. This may not be doable with the current edje architecture, but I really think this is crucial and it should speed up the process.

TOO DIFFICULT theme customization.

You are right. this is a combination of edc being very low level and themes just specifying a LOT of stuff. if themes did less, they'd be simpler. then code would do more of course. Having a simpler set of color classes to modify to change color scheme was one of those "make it easier. edc was a temporary solution to "get data into a file". it has stuck around. if someone wants to make a higher level language that compiles down to edc... please do! i don't see any problem with that. but in the end thats what gui design tools were meant to solve. produce a very high level visual designer... :)

Light theme, OK cool.

If I get things right for the default theme, this wouldn't need to be separately maintained. it just would be an alternate colorclasses.edc file... in fact it shouldn't even be a separate edj file. it should be a "config blob" for elm config that overrides the colorclasses for the default theme. thus you'd have a "light" colorclass set. you could have beige, pink, purple, rainbow unicorn.... whatever you like as a set of colors that override. this is the whole purpose of colorclasses ... to do just this. i see no issue with us shipping color scheme "config blobs" (files - probably eet files compiled from colroclass src files) where a user can pick a theme THEN also pick a colorscheme or make a customn one of their own (or even have the config tool load an image file and create a color scheme from the image that matches it).

of course this relies on having a theme that re-colors really easily. and that was kind of my point for the flat theme - it will do just that (eventually when i get to that point... still doing the basics now). :) of course help will be much appreciated. then everyone can be happy with the colors they want.

So I think each widget should have a contract/grammar/rules like this widget

yes. it'd need a document per widget or object listing the group(s) needed and exactly how they work, the contract for swallows, text, signals etc. etc. ... this is in and of itself a lot of work though... :)

With enventor you can edit your edc, but it compiles the edc and the latency is killing me

actually it should be able to be improved if edje_cc had a "modify" mode that left most of the eet keys alone (just read and re-wrote them without decompress/re-compress which is what eet does when opening for read+write from memory). its really the compression that easts up all the time and it recompresses EVERYTHING each time.

@raster can you create a workboard here on phab for the default theme, lets assume its going to be flat that you've been working on, and create tickets/tasks for everything that needs to be done to complete it - and to complete it having both light and dark styles? Then the rest of us can start pitching in and helping to try and get something done.

So I think each widget should have a contract/grammar/rules like this widget

yes. it'd need a document per widget or object listing the group(s) needed and exactly how they work, the contract for swallows, text, signals etc. etc. ... this is in and of itself a lot of work though... :)

we can start with one widget at a time, while making sure new widgets are not added without this document.
If you think we should do this, let's open a new task?

With enventor you can edit your edc, but it compiles the edc and the latency is killing me

actually it should be able to be improved if edje_cc had a "modify" mode that left most of the eet keys alone (just read and re-wrote them without decompress/re-compress which is what eet does when opening for read+write from memory). its really the compression that easts up all the time and it recompresses EVERYTHING each time.

Isn't it possible to have a runtime representation of the edc text? and then changing one character/one line in the text, changes the variable in memory and then we update the object on screen?
maybe it isn't possible or easily doable now but isn't it something we should have?

zmike edited projects, added Restricted Project; removed efl, enlightenment-git.Feb 23 2018, 11:01 AM
zmike removed zmike as the assignee of this task.
zmike removed a subscriber: zmike.

Please look at this ticket I made.

T6726: E/EFL Flat Theme

Continue discussion there so we can work our way to having color class schemes etc. etvc. and the argument is over then like it is for scaling.